/* l'omettino LEGO */

#include "descriptor/descriptor.h"

#define STEP -1.5
#define XMIN -16
#define XMAX 16
#define YMIN -15
#define YMAX 16
#define BRICK_H 1.7

int main(void) {

ITEM Lego, Corpo, Bacino, GambaA, GambaB, BraccioA, BraccioB, Testa, Pavimento, Mattoncino1, Mattoncino2;

ITEM Mattoncino1b, Mattoncino2b, Mattoncino2c;

ITEM giallo, rosso, blu, nero, grigio, bianco, verde, marroncino;
ITEM luce;
ITEM testa, testa2;
ITEM collo, corpo_top, corpo_bottom;
ITEM braccio, bracciob;
ITEM polso, polsob, mano, manob;
ITEM bacino1, bacino2;
ITEM gamba1, gamba2, gamba3, gamba1b, gamba2b, gamba3b;
ITEM pavimento, muro1, muro2, cerchietto;
ITEM brick1, bc1, bc2;
ITEM brick2, bc1_2;
int m=XMAX - XMIN + 1;
int n=YMAX - YMIN + 1;
int i,j;	
ITEM cerchietti[m][n];


/* Sfondo e luci */
set_background ( 0.9, 0.9, 0.6, 1 );

set_ambient_light ( 1, 1, 1, 0.5 );

luce = create_point_light( 9.72, -10.99, 8.52, 1, 1, 1, 1, 0, "luce" );


/* Attributi */
giallo = create_attribute( "giallo" );
set_color ( giallo, 1, 1, 0, 0.1, 0.9 );
set_reflectivity ( giallo, 0.01, 2 );

rosso = create_attribute( "rosso" );
set_color ( rosso, 1, 0, 0, 0.1, 0.9 );
set_reflectivity ( rosso, 0.01, 2 );

blu = create_attribute( "blu" );
set_color ( blu, 0, 0, 1, 0.1, 0.9 );
set_reflectivity ( blu, 0.01, 2 );

nero = create_attribute( "nero" );
set_color ( nero, 0, 0, 0, 0.1, 0.9 );
set_reflectivity ( nero, 0.01, 2 );

grigio = create_attribute( "grigio" );
set_color ( grigio, 0.7, 0.7, 0.7, 0.1, 0.9 );
set_reflectivity ( grigio, 0.01, 2 );

bianco = create_attribute( "bianco" );
set_color ( bianco, 1, 1, 1, 0.1, 0.9 );
set_reflectivity ( bianco, 0.01, 2 );

verde = create_attribute( "verde" );
set_color ( verde, 0, 1, 0, 0.1, 0.8 );
set_reflectivity ( verde, 0.1, 2 );

marroncino = create_attribute( "marroncino");
set_color ( marroncino, 0.9, 0.9, 0.6, 0, 1 );
set_reflectivity ( marroncino, 0, 2 );

/* Oggetti */
testa = read_nurbs ( "facciaA.dbe" );
set_attribute ( testa, giallo );
testa2 = read_nurbs( "facciaB.db" );
set_attribute ( testa2, giallo );
set_translate( testa, 0, 0, -5 );
set_x_rotate( testa, 90, 1 );
set_y_rotate( testa, -60, 1 );
set_projection_texture ( testa, giallo, "textures/faccia.hr", FALSE, FALSE, 0, 1 );
set_y_rotate( testa, 60, 1 );
set_x_rotate( testa, -90, 1 );
set_translate ( testa, 0, 0, 5 );
collo = read_nurbs ( "collo.db" );
set_attribute ( collo, rosso );

corpo_top = read_nurbs ( "corpo_top.db" );
set_attribute ( corpo_top, rosso );

corpo_bottom = read_nurbs ( "corpo_bottom.dbe" );
set_attribute ( corpo_bottom, rosso );

bacino1 = read_nurbs ( "bacino_1.db" );
set_attribute ( bacino1, nero );

bacino2 = read_nurbs ( "bacino_2.db" );
set_attribute ( bacino2, nero );

braccio = read_nurbs ( "braccio.db" );
set_attribute ( braccio, rosso );

bracciob = read_nurbs ( "bracciob.db" );
set_attribute ( bracciob, rosso );

polso = read_nurbs ( "polso.db" );
set_attribute ( polso, giallo );

polsob = read_nurbs ( "polsob.db" );
set_attribute ( polsob, giallo );

mano = read_nurbs ( "mano.dbe" );
set_attribute ( mano, giallo );

manob = read_nurbs ( "manob.dbe" );
set_attribute ( manob, giallo );

gamba1 = read_nurbs ( "gamba_1.db" );
set_attribute ( gamba1, blu );

gamba2 = read_nurbs ( "gamba_2.db" );
set_attribute ( gamba2, blu );

gamba3 = read_nurbs ( "gamba_3.db" );
set_attribute ( gamba3, blu );

gamba1b = read_nurbs ( "gamba_1b.db" );
set_attribute ( gamba1b, blu );

gamba2b = read_nurbs ( "gamba_2b.db" );
set_attribute ( gamba2b, blu );

gamba3b = read_nurbs ( "gamba_3b.db" );
set_attribute ( gamba3b, blu );

pavimento = read_nurbs ( "pavimento.db" );
set_attribute ( pavimento, verde );

muro1 = read_nurbs ( "muro1.db" );
set_attribute ( muro1, marroncino );

muro2 = read_nurbs ( "muro2.db" );
set_attribute ( muro2, marroncino );

cerchietto = read_nurbs ( "cerchietto.db" );
set_attribute ( cerchietto, verde );

for (i=0;i<m;i++)
{
	for (j=0;j<n;j++)
	{
		char name[10];
		sprintf(name, "c%d%d",i,j);
		cerchietti[i][j]=create_copy ( cerchietto, name );
		set_translate ( cerchietti[i][j], (XMIN + i)*STEP, (YMIN + j)*STEP, 0 );
	}
}

brick1 = read_nurbs ( "brick2x1.db" );
set_attribute ( brick1, grigio );
set_translate ( brick1, -2*STEP, -2*STEP, 0 );
bc1 = create_copy ( cerchietto, "bc1" );
set_attribute ( bc1, grigio );
set_translate ( bc1, -2*STEP, -2*STEP, BRICK_H );
bc2 = create_copy ( bc1, "bc2" );
set_translate ( bc1, -1*STEP, 0, 0 );

brick2 = read_nurbs ( "brick1x1.db" );
set_attribute ( brick2, bianco );
set_translate ( brick2, 6*STEP, -13*STEP, 0 );
bc1_2 = create_copy ( cerchietto, "bc1_2" );
set_attribute ( bc1_2, bianco );
set_translate ( bc1_2, 6*STEP, -13*STEP, BRICK_H );

/* Gerarchia */
Testa = create_list ( testa, "testa" );
Testa = insert_in_list ( Testa, testa2 );

Lego = create_list ( Testa, "lego" );

Corpo = create_list ( collo, "corpo");
Corpo = insert_in_list ( Corpo, corpo_top );
Corpo = insert_in_list ( Corpo, corpo_bottom );
Lego = insert_in_list ( Lego, Corpo );

Bacino = create_list ( bacino1,  "bacino" );
Bacino = insert_in_list ( Bacino, bacino2 );
Lego = insert_in_list ( Lego, Bacino );

GambaA = create_list ( gamba1, "gamba1" );
GambaA = insert_in_list ( GambaA, gamba2 );
GambaA = insert_in_list ( GambaA, gamba3 );
Lego = insert_in_list ( Lego, GambaA );

GambaB = create_list ( gamba1b, "gamba2" );
GambaB = insert_in_list ( GambaB, gamba2b );
GambaB = insert_in_list ( GambaB, gamba3b );
Lego = insert_in_list ( Lego, GambaB );

BraccioA = create_list ( braccio, "braccio1" );
BraccioA = insert_in_list ( BraccioA, polso );
BraccioA = insert_in_list ( BraccioA, mano );
Lego = insert_in_list ( Lego, BraccioA );

BraccioB = create_list ( bracciob, "braccio2" );
BraccioB = insert_in_list ( BraccioB, polsob );
BraccioB = insert_in_list ( BraccioB, manob );
Lego = insert_in_list ( Lego, BraccioB );

Pavimento = create_list ( pavimento, "scena" );
Pavimento = insert_in_list ( Pavimento, muro1 );
Pavimento = insert_in_list ( Pavimento, muro2 );
Pavimento = insert_in_list ( Pavimento, cerchietto );
for (i=0;i<m;i++)
{
        for (j=0;j<n;j++)
	        {
			Pavimento = insert_in_list ( Pavimento, cerchietti[i][j] );
		}
}
Lego = insert_in_list ( Lego, Pavimento );

Mattoncino1 = create_list ( brick1, "mattoncino1" );
Mattoncino1 = insert_in_list ( Mattoncino1, bc1 );
Mattoncino1 = insert_in_list ( Mattoncino1, bc2 );
Lego = insert_in_list ( Lego, Mattoncino1 );

Mattoncino1b = create_copy ( Mattoncino1, "mattoncino3" );
set_z_rotate ( Mattoncino1b, 90, 1 );
set_translate ( Mattoncino1b, -6*STEP, -8*STEP, 0 );
set_attribute ( Mattoncino1b, bianco );
Lego = insert_in_list ( Lego, Mattoncino1b );

Mattoncino2 = create_list (brick2, "mattoncino2" );
Mattoncino2 = insert_in_list ( Mattoncino2, bc1_2 );
Lego = insert_in_list ( Lego, Mattoncino2 );

Mattoncino2b = create_copy ( Mattoncino2, "mattoncino4" );
set_translate ( Mattoncino2b, -9*STEP, 1*STEP, BRICK_H );
set_attribute ( Mattoncino2b, grigio );		
Lego = insert_in_list ( Lego, Mattoncino2b );

Mattoncino2c = create_copy ( Mattoncino2, "mattoncino5" );
set_translate ( Mattoncino2c, -8*STEP, 1*STEP, 0 );
set_attribute ( Mattoncino2c, bianco );
Lego = insert_in_list ( Lego, Mattoncino2c );

save_scene ( "lego.md" , "Lego" , Lego ) ;
return(0);
}
